Loading...
Searching...
No Matches
openshot::Caption Class Reference

This class adds captions/text over a video, based on timestamps. You can also animate some limited aspects, such as words appearing/disappearing. More...

`#include <effects/Caption.h>`

Inheritance diagram for openshot::Caption:

## Public Member Functions

| Caption ()
| Blank constructor, useful when using Json to load the effect properties.
| Caption (std::string captions)
std::string | CaptionText ()
| Set the caption string to use (see VTT format).
void | CaptionText (std::string new_caption_text)
| Get the caption string.
std::shared_ptr< openshot::Frame > | GetFrame (int64_t frame_number) override
| This method is required for all derived classes of ClipBase, and returns a new openshot::Frame object. All Clip keyframes and effects are resolved into pixels.
std::shared_ptr< openshot::Frame > | GetFrame (std::shared_ptr< openshot::Frame > frame, int64_t frame_number) override
| This method is required for all derived classes of ClipBase, and returns a modified openshot::Frame object.
std::string | Json () const override
| Generate JSON string of this object.
Json::Value | JsonValue () const override
| Generate Json::Value for this object.
std::string | PropertiesJSON (int64_t requested_frame) const override
void | SetJson (const std::string value) override
| Load JSON string into this object.
void | SetJsonValue (const Json::Value root) override
| Load Json::Value into this object.
Public Member Functions inherited from openshot::EffectBase
Json::Value | BasePropertiesJSON (int64_t requested_frame) const
| Generate JSON object of base properties (recommended to be used by all effects).
int | constrain (int color_value)
| Constrain a color value from 0 to 255.
void | DisplayInfo (std::ostream *out=&std::cout)
| Display effect information in the standard output stream (stdout).
virtual std::string | GetVisibleObjects (int64_t frame_number) const
| Get the indexes and IDs of all visible objects in the given frame.
void | InitEffectInfo ()
virtual std::string | Json (int64_t requested_frame) const
Json::Value | JsonInfo () const
| Generate JSON object of meta data / info.
int | Order () const
| Get the order that this effect should be executed.
void | Order (int new_order)
| Set the order that this effect should be executed.
openshot::ClipBase * | ParentClip ()
| Parent clip object of this effect (which can be unparented and NULL).
void | ParentClip (openshot::ClipBase *new_clip)
| Set parent clip object of this effect.
std::string | ParentClipId () const
| Return the ID of this effect's parent clip.
virtual void | SetJson (int64_t requested_frame, const std::string value)
void | SetParentEffect (std::string parentEffect_id)
| Set the parent effect from which this properties will be set to.
virtual | ~EffectBase ()=default
Public Member Functions inherited from openshot::ClipBase
| ClipBase ()
| Constructor for the base clip.
float | Duration () const
| Get the length of this clip (in seconds).
virtual float | End () const
| Get end position (in seconds) of clip (trim end of video).
virtual void | End (float value)
| Set end position (in seconds) of clip (trim end of video).
std::string | Id () const
| Get the Id of this clip object.
void | Id (std::string value)
int | Layer () const
| Get layer of clip on timeline (lower number is covered by higher numbers).
void | Layer (int value)
| Set layer of clip on timeline (lower number is covered by higher numbers).
bool | operator< (ClipBase &a)
bool | operator<= (ClipBase &a)
bool | operator> (ClipBase &a)
bool | operator>= (ClipBase &a)
virtual openshot::TimelineBase * | ParentTimeline ()
| Get the associated Timeline pointer (if any).
virtual void | ParentTimeline (openshot::TimelineBase *new_timeline)
| Set associated Timeline pointer.
float | Position () const
| Get position on timeline (in seconds).
void | Position (float value)
| Set position on timeline (in seconds).
float | Start () const
| Get start position (in seconds) of clip (trim start of video).
void | Start (float value)
| Set start position (in seconds) of clip (trim start of video).
virtual | ~ClipBase ()=default

## Public Attributes

Color | background
| Color of caption area background.
Keyframe | background_alpha
| Background color alpha.
Keyframe | background_corner
| Background cornder radius.
Keyframe | background_padding
| Background padding.
Color | color
| Color of caption text.
Keyframe | fade_in
| Fade in per caption (# of seconds).
Keyframe | fade_out
| Fade in per caption (# of seconds).
Keyframe | font_alpha
| Font color alpha.
std::string | font_name
| Font string.
Keyframe | font_size
| Font size in points.
Keyframe | left
| Size of left bar.
Keyframe | line_spacing
| Distance between lines (1.0 default / 100%).
Keyframe | right
| Size of right bar.
Color | stroke
| Color of text border / stroke.
Keyframe | stroke_width
| Width of text border / stroke.
Keyframe | top
| Size of top bar.
Public Attributes inherited from openshot::EffectBase
EffectInfoStruct | info
| Information about the current effect.
EffectBase * | parentEffect
| Parent effect (which properties will set this effect properties).
std::map< int, std::shared_ptr< openshot::TrackedObjectBase > > | trackedObjects
| Map of Tracked Object's by their indices (used by Effects that track objects on clips).

## Additional Inherited Members

Protected Member Functions inherited from openshot::ClipBase
Json::Value | add_property_choice_json (std::string name, int value, int selected_value) const
| Generate JSON choice for a property (dropdown properties).
Json::Value | add_property_json (std::string name, float value, std::string type, std::string memo, const Keyframe *keyframe, float min_value, float max_value, bool readonly, int64_t requested_frame) const
| Generate JSON for a property.
Protected Attributes inherited from openshot::EffectBase
openshot::ClipBase * | clip
| Pointer to the parent clip instance (if any).
Protected Attributes inherited from openshot::ClipBase
float | end
| The position in seconds to end playing (used to trim the ending of a clip).
std::string | id
| ID Property for all derived Clip and Effect classes.
int | layer
| The layer this clip is on. Lower clips are covered up by higher clips.
float | position
| The position on the timeline where this clip should start playing.
std::string | previous_properties
| This string contains the previous JSON properties.
float | start
| The position in seconds to start playing (used to trim the beginning of a clip).
openshot::TimelineBase * | timeline
| Pointer to the parent timeline instance (if any).

## Detailed Description

This class adds captions/text over a video, based on timestamps. You can also animate some limited aspects, such as words appearing/disappearing.

Adding captions can be an easy way to generate text overlays through-out a long clip.

Definition at line 38 of file Caption.h.

## Constructor & Destructor Documentation

## Caption() [1/2]

Caption::Caption | ( |  | ) |

Blank constructor, useful when using Json to load the effect properties.

Definition at line 30 of file Caption.cpp.

## Caption() [2/2]

Caption::Caption | ( | std::string | captions | ) |

Default constructor, which takes a string of VTT/Subrip formatted caption data, and displays them over time.

Parameters

  captions | A string with VTT/Subrip format text captions

Definition at line 39 of file Caption.cpp.

## Member Function Documentation

## CaptionText() [1/2]

std::string Caption::CaptionText | ( |  | ) |

Set the caption string to use (see VTT format).

Definition at line 69 of file Caption.cpp.

## CaptionText() [2/2]

void Caption::CaptionText | ( | std::string | new_caption_text | ) |

Get the caption string.

Definition at line 74 of file Caption.cpp.

## GetFrame() [1/2]

std::shared_ptr< openshot::Frame > openshot::Caption::GetFrame | ( | int64_t | frame_number | ) |

inline override virtual

This method is required for all derived classes of ClipBase, and returns a new openshot::Frame object. All Clip keyframes and effects are resolved into pixels.

Returns
  A new openshot::Frame object

Parameters

  frame_number | The frame number (starting at 1) of the clip or effect on the timeline.

Implements openshot::ClipBase.

Definition at line 86 of file Caption.h.

Referenced by GetFrame().

## GetFrame() [2/2]

std::shared_ptr< openshot::Frame > Caption::GetFrame | ( | std::shared_ptr< openshot::Frame > | frame,
|  | int64_t | frame_number )

override virtual

This method is required for all derived classes of ClipBase, and returns a modified openshot::Frame object.

The frame object is passed into this method and used as a starting point (pixels and audio). All Clip keyframes and effects are resolved into pixels.

Returns
  The modified openshot::Frame object

Parameters

  frame | The frame object that needs the clip or effect applied to it
  frame_number | The frame number (starting at 1) of the clip or effect on the timeline.

Implements openshot::ClipBase.

Definition at line 108 of file Caption.cpp.

## Json()

std::string Caption::Json | ( |  | ) | const

override virtual

Generate JSON string of this object.

Reimplemented from openshot::EffectBase.

Definition at line 372 of file Caption.cpp.

## JsonValue()

Json::Value Caption::JsonValue | ( |  | ) | const

override virtual

Generate Json::Value for this object.

Reimplemented from openshot::EffectBase.

Definition at line 379 of file Caption.cpp.

Referenced by Json().

## PropertiesJSON()

std::string Caption::PropertiesJSON | ( | int64_t | requested_frame | ) | const

override virtual

Get all properties for a specific frame (perfect for a UI to display the current state of all properties at any time)

Implements openshot::ClipBase.

Definition at line 470 of file Caption.cpp.

## SetJson()

void Caption::SetJson | ( | const std::string | value | ) |

override virtual

Load JSON string into this object.

Reimplemented from openshot::EffectBase.

Definition at line 407 of file Caption.cpp.

## SetJsonValue()

void Caption::SetJsonValue | ( | const Json::Value | root | ) |

override virtual

Load Json::Value into this object.

Reimplemented from openshot::EffectBase.

Definition at line 424 of file Caption.cpp.

Referenced by SetJson().

## Member Data Documentation

## background

Color openshot::Caption::background

Color of caption area background.

Definition at line 57 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## background_alpha

Keyframe openshot::Caption::background_alpha

Background color alpha.

Definition at line 58 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## background_corner

Keyframe openshot::Caption::background_corner

Background cornder radius.

Definition at line 59 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## background_padding

Keyframe openshot::Caption::background_padding

Background padding.

Definition at line 60 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## color

Color openshot::Caption::color

Color of caption text.

Definition at line 55 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## fade_in

Keyframe openshot::Caption::fade_in

Fade in per caption (# of seconds).

Definition at line 68 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## fade_out

Keyframe openshot::Caption::fade_out

Fade in per caption (# of seconds).

Definition at line 69 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## font_alpha

Keyframe openshot::Caption::font_alpha

Font color alpha.

Definition at line 63 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## font_name

std::string openshot::Caption::font_name

Font string.

Definition at line 70 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## font_size

Keyframe openshot::Caption::font_size

Font size in points.

Definition at line 62 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## left

Keyframe openshot::Caption::left

Size of left bar.

Definition at line 65 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## line_spacing

Keyframe openshot::Caption::line_spacing

Distance between lines (1.0 default / 100%).

Definition at line 64 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## right

Keyframe openshot::Caption::right

Size of right bar.

Definition at line 67 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## stroke

Color openshot::Caption::stroke

Color of text border / stroke.

Definition at line 56 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## stroke_width

Keyframe openshot::Caption::stroke_width

Width of text border / stroke.

Definition at line 61 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

## top

Keyframe openshot::Caption::top

Size of top bar.

Definition at line 66 of file Caption.h.

Referenced by Caption(), Caption(), GetFrame(), JsonValue(), PropertiesJSON(), and SetJsonValue().

The documentation for this class was generated from the following files:

- effects/Caption.h
- effects/Caption.cpp